/***************************************************************************
                          game.h  -  description
                             -------------------
    begin                : St z 17 2003
    copyright            : (C) 2003 by Petr Cermak
    email                : cermak01@seznam.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _GAME_H_
#define _GAME_H_

#include "shared.h"

/**
 * State of one field in the game array
 */
#define FS_BLUE 0
#define FS_RED 1
#define FS_BLANK 2
#define FS_BLUEX 3
#define FS_REDX 4
typedef char FieldState;

/**
 * Who's on the turn
 */
#define GS_BLUE FS_BLUE
#define GS_RED FS_RED
#define GS_NOBODY 2
typedef char GameState;

/**
 * Describes one game
 */
typedef struct {
	GameState whoAmI;
	int rows;
	int cols;
	FieldState** fields;
	int empty;
	GameState gs;
	int redScore;
	int blueScore;
	int pisLen;
} Game;

Game* newGame(int rows, int cols, GameState whoStarts, GameState whoAmI, int pisLen);
void deleteGame(Game* g);
void oppositeWhoAmI(Game* g);
void switchTurn(Game* g);
Boolean playAt(Game* g, FieldState fs, int x, int y);


void pokus();
#endif
